/*
 * comunications.h
 *
 *  Created on: 19/09/2011
 *      Author: ccortiz
 */

#ifndef COMUNICATIONS_H_
#define COMUNICATIONS_H_


#include "juce.h"
#include "generiCom.h"

#define _N_MAX_INTERFACES_ 5

enum confStatus{_Conf_OK_, _Conf_ERROR_};


class comunications:public Thread {
public:
//	editorFactory* r_editorFactory;
	static comunications* getRef();

	void setLogDirectory(String logPath);
	void appendInterface(generiCom* interfaceClass, String interfaceName);
	int  selectInterface(String interfaceName);
	confStatus configureInterface(void* confStruct);

	comStatus initialize();
	int sendBuffer(char* buffer, int length, String messageAlias="");
	int receiveBuffer();
	char* getRxBuffer();
	void setMonitorRef(void *ptr);
	void setConfiguratorRef(void* ptr);
	virtual ~comunications();


private:
	void run();
	comunications();
	void saveLog(char* r_dataBuffer, int nBytes, String messageName);

	int r_nInterfaces;
	int r_currentInterface;
	generiCom* comArray[_N_MAX_INTERFACES_];
	String comNames[_N_MAX_INTERFACES_];
	char r_dataBuffer[_MAX_INCOMMING_BUFFER_SIZE_];
	void* r_monitorPtr;
	void* r_configuratorPtr;
	unsigned int r_msgCounter;
	String r_msgFullPath;

	CriticalSection mutex;
	//TODO AADIR MUTEX (CriticalSection)
};

#endif /* COMUNICATIONS_H_ */
